// *********************************************************************
// *                Configurationfile for RMNEWS                       *
// *********************************************************************

// MONTHS=Definition of 3-char shortcuts for the month
// MONTHS='JanFebMarAprMayJunJulAugSepOctNovDec'; (default)
// MONTHS='JanFebMrzAprMaiJunJulAugSepOktNovDez';

// WEEKDAYS=Definition of 2-char chortcuts for the weekday
// WEEKDAYS='SuMoTuWeThFrSa'; (default)
// WEEKDAYS='SoMoDiMiDoFrSa';

// DATE=If specified: use format DD.MM.YYYY for overwriting the systemdate
//      systemdate doesn't change ...
//      There are a set of date-variables: 
//      (i.e. systemdate=03 Feb 1996  and DATE=05.06.1995)
//      $ADATE-D    = _3     $NDATE-D    = _5
//      $ADATE-DD   = 03     $NDATE-DD   = 05
//      $ADATE-M    = _2     $NDATE-M    = _6
//      $ADATE-MM   = 02     $NDATE-MM   = 06
//      $ADATE-MMM  = Feb    $NDATE-MMM  = Jun
//      $ADATE-YY   = 96     $NDATE-YY   = 95 
//      $ADATE-YYYY = 1996   $NDATE-YYYY = 1995
//      ... for use in header/footer files i.e.
// DATE=05.02.1996;  

// HNEWS=Name of the paper, used for Headlines (Value of $HNAME)
// HNEWS='FIDONEWS';   (default)
HNEWS='GNEWS   ';

// VOLUME=volume-no of the actual issue
//        (used to built some variables:)
//        (VOLUME=1  -> $VOLUMEF='01')
//        (VOLUME=10 -> $VOLUMEH='A')
// have a look at RMNEWS.VAR 
// VOLUME=13

// ISSUE=issue-no of the actual issue
//       (used to built $ISSUEF:)
//       (ISSUE=3 -> $ISSUEF='03')
// have a look at RMNEWS.VAR 
// ISSUE=36

// NEWS=5-character word, which is used to specifiy includefiles etc.
// NEWS=FNEWS; (default)
// NEWS=GNEWS;

// TICAREA=FIDONEWS; (default)
// TICAREA=GNEWS;

// TICAREAD='FidoNet: Weekly FidoNews Newsletter'; (default)
// TICAREAD='Fido-R24: Ausgaben der German FidoNews';

// TICPASSWD=fidonews (default)
// TICPASSWD=history

// TICOWN=1:1/23 (default)
// TICOWN=2:2433/433

// TICDESC='FidoNews volume '$VOLUMEF' issue '$ISSUEF', '$ADATE-YYYY   (default)
// TICDESC=$HNAME', Jahrgang '$VOLUMEF', Ausgabe '$ISSUEF' vom '$NDATE-DD.$NDATE-MM.$NDATE-YYYY

// ISSUEDIR=
ISSUEDIR=S:\TEMP\PRG\BP70\$NEWS\$VOLUMEF$ISSUEF;

// INCLUDEDIR=
INCLUDEDIR=S:\TEMP\PRG\BP70\$NEWS\INCLUDE;

// TEXTFILE=Name of the textfile of newspaper to be produced
TEXTFILE=$ISSUEDIR\FIDO$VOLUMEF$ISSUEF.NWS

// ARCNAME=Name of the archive in which will $TEXTFILE be packed.
// There MUST be the extention (no extention -> not the complete filename
//                              in the Tic-File)
ARCNAME=$ISSUEDIR\$NEWS$VOLUMEH$ISSUEF.ZIP;  

// PACKCOMMAND=Command to be executed to pack the textfile into the archive
PACKCOMMAND=pkzip' -ex -o '$ARCNAME' '$TEXTFILE' '$ISSUEDIR\FILE_ID.DIZ

// PAGELENGTH=59; (default)
PAGELENGTH=66

// OFFSET=5
OFFSET=5

// WIDTH=70 (produces warnings)
WIDTH=72

// TOCLINES=2 (default) (effektive lines which will be included in 
//                       TOC, if they begin with '*')
TOCLINES=5

// TOCFILLCHAR=.
// TOCFILLCHAR=_

// STARTPAGE=1
// have a look at RMNEWS.VAR 
// next issue starts with this page-no. !

// VAR-STARTPAGE='Y';   page of next issue starts with lastpage from
//                      last issue.  (continued pagenumbering)  (default)
//               'N';   Every issue starts with page 1.
//                      --> generates a 'STARTPAGE=1' in every RMNEWS.VAR

// BREAKSIGN='**=*=**'; (default)

   NEWPG-PRODUCE=!BEG;    Banner-Section 

   NEWPG-PRODUCE=!TOC;    TOC-dummy-entry

   NEWPG-PRODUCE=#GUE,'Editorial';

//                 includes all files, which match $ISSUEDIR\*.ART
//                 * The programm will have a look at 1. $ISSUEDIR\ART.x
//                                                    2. $INCLUDEDIR\ART.x
//                                                    3. $INCLUDEDIR\$NEWS.x
//                   where x is (HED=Header, BAN=Banner, FOT=Footer)
//                
//                     Name of the section, to be included in TOC
   BREAK-PRODUCE=#ART,'Articels';
//     
//     BREAK:= After each submission a BreakSign is written
//     NEWPG:= After each submission a NewPage X'0C' is written

   NEWPG-PRODUCE=#RET,'Retractions';

   NEWPG-PRODUCE=#HIS,'Fidonet History';

   NEWPG-PRODUCE=#BIO,'Fidonet Biographies';

   BREAK-PRODUCE=#REV,'Reviews';

   NEWPG-PRODUCE=#COR,'Coordinators Corner';

   NEWPG-PRODUCE=#ECO,'Echoing';

   BREAK-PRODUCE=#EMA,'We get eMail';

   BREAK-PRODUCE=#PRF,'Proofreader report';

   BREAK-PRODUCE=#JOK,'Net Humor';

   BREAK-PRODUCE=#CMX,'Comix in ASCII';

   BREAK-PRODUCE=#QUE,'Question of the week';

   BREAK-PRODUCE=#ADV,'Advertising FREE services';

   BREAK-PRODUCE=#NOT,'Notices';
//               
//               # means 'submission' (prg will look at $ISSUEDIR)

   BREAK-PRODUCE=!FSL,'Fidonet Software Listing';
//               
//               # means 'include' (prg will look at $INCLUDEDIR\$NEWS.FSL)

   BREAK-PRODUCE=!FPK,'Fidonews Public-Key';

   BREAK-PRODUCE=!INF,'Fidonews Information';

