PROGRAM RMNEWS;

USES Dos, Crt;

{$M 64000,0,0 }

TYPE  st_4    = String[4];
      st_15   = String[15];
      star_4  = Array[0..3] of st_4;
      star_10 = Array[0..9] of st_4;
     (* For Dec2Roman *)

CONST Wunz:  star_10 = ('','i','ii','iii','iv','v','vi','vii','viii','ix');
      Tenz:  star_10 = ('','x','xx','xxx','xl','l','lx','lxx','lxxx','xc');
      Hunz:  star_10 = ('','c','cc','ccc','cd','d','dc','dcc','dccc','cm');
      Thouz: star_4  = ('','m','mm','mmm');
     (* For Dec2Roman *)

CONST OutRedir: BOOLEAN = FALSE;

CONST Version='1.0';
      PrgName='RMNews';
      Author='Ralf Mahler';
      Node='(2:2433/433)';
      Year='1996';
      space='                                                     ';
      minus='-----------------------------------------------------';
      equal='=====================================================';
      ff=CHR(12);
      filedebug=FALSE;

      varfile='RMNEWS.VAR';
      ctlfile='RMNEWS.CTL';
      elogfile='CALLEPRG.LOG';

      (* For protocol *)
      c_sectionf   ='section is ';

      c_h_look1    ='   looking for ';
      c_h_look2    ='header';
      c_h_name     ='        assumed name is ';
      c_h_nohead   ='                        no header to include';

      c_b_look1    ='   looking for ';
      c_b_look2    ='banner';
      c_b_name     ='        assumed name is ';
      c_b_nobann   ='                        no banner to include';

      c_s_look1    ='   looking for ';
      c_s_look2a   ='submissions';
      c_s_look2b   ='include';
      c_s_path     ='      assumed names are ';
      c_s_pathna   ='        assumed name is ';
      c_s_inclfb   ='              including ';
      c_s_incln    ='                no such ';

      c_f_look1    ='   looking for ';
      c_f_look2    ='footer';
      c_f_name     ='        assumed name is ';
      c_f_nofoot   ='                        no footer to include';

      c_merge1     ='merging files ......... ';
      c_merge2     ='                    and ';
      c_merge3     ='                     to ';

      c_setvar     ='setting new variables : ';

      c_callpack   ='executing program ..... ';

      c_creafile   ='creating file ......... ';

TYPE BreakType   = ( Break, NewPage );
     TOCStatType = ( Before, Now, After );

TYPE INCPointerType = ^INCRecType;
     INCRecType = RECORD
                    ipath: STRING;
                    next:  INCPointerType;
                  END;

TYPE  CtrlRec = RECORD
		  MONTHS:	STRING;
 		  WEEKDAYS:	STRING;

                  IDATE_DD:     WORD;     (* internal *)
                  IDATE_MM:     WORD;     (* internal *)
                  IDATE_JJJJ:   WORD;     (* internal *)
                  IDATE_WD:     WORD;     (* internal *)

                                          (* systemdate *)
                  ADATE_D:      STRING;   (* 1 *)
                  ADATE_DD:     STRING;   (* 01 *)
                  ADATE_M:      STRING;   (* 1 *)
                  ADATE_MM:     STRING;   (* 01 *)
                  ADATE_MMM:    STRING;   (* Jan *)
                  ADATE_JJ:     STRING;   (* 96 *)
                  ADATE_JJJJ:   STRING;   (* 1996 *)
                  ADATE_WD:     STRING;   (* Su *)

                                          (* simulated date *)
                  NDATE_D:      STRING;   (* 1 *)
                  NDATE_DD:     STRING;   (* 01 *)
                  NDATE_M:      STRING;   (* 1 *)
                  NDATE_MM:     STRING;   (* 01 *)
                  NDATE_MMM:    STRING;   (* Jan *)
                  NDATE_JJ:     STRING;   (* 96 *)
                  NDATE_JJJJ:   STRING;   (* 1996 *)
                  NDATE_WD:     STRING;   (* Su *)

                  HNAME:	STRING;
		  VOLUME:	INTEGER;
		  VOLUMEF:	STRING;
		  VOLUMEH:	STRING;
		  ISSUE:	INTEGER;
		  ISSUEF:       STRING;
		  NEWS:		STRING;
		  ISSUEDIR:	STRING;
		  INCLUDEDIR:	STRING;
		  TEXTFILE:	STRING;
		  ARCNAME:	STRING;
		  PACKCOMMAND:	STRING;
                  PAGELENGTH:   INTEGER;
                  OFFSET:       INTEGER;
                  WIDTH:        INTEGER;
                  TICAREA:      STRING;
                  TICAREAD:     STRING;
                  TICPASSWD:    STRING;
                  TICOWN:       STRING;
                  TICDESC:      STRING;
                  TICPATH:      STRING;
                  BREAKSIGN:    STRING;

                  SECNAME:      STRING;
                  SECFLAG:      CHAR;
                  SECSHORT:     STRING;
                  SECNUM:       INTEGER;
                  ISSFILES:     STRING;
                  HEADPATH1:    STRING;
                  BANNPATH1:    STRING;
                  FOOTPATH1:    STRING;
                  HEADPATH2:    STRING;
                  BANNPATH2:    STRING;
                  FOOTPATH2:    STRING;
                  HEADPATH3:    STRING;
                  BANNPATH3:    STRING;
                  FOOTPATH3:    STRING;
                  HEADINCL:     STRING;
                  BANNINCL:     STRING;
                  FOOTINCL:     STRING;
                  FOOTLENG:     INTEGER;
                  FINCP:        INCPointerType; (* Pointer to first Include *)
                                                (* in the achtual section *)
                  NOOFISS:      INTEGER;
                  ANOOFISS:     INTEGER;
                  BREAK_NP:     BreakType;

                  TOCNAME:      STRING;
                  TOCHANDLE:    TEXT;
                  BEFTOC:       STRING;
                  BEFTOCHANDLE: TEXT;
                  AFTTOC:       STRING;
                  AFTTOCHANDLE: TEXT;
                  TOCWAS:       TOCStatType;
                  TOCLINES:     INTEGER;
                  TOCFILLCHAR:  STRING;
                  TOCFIL:       STRING;

                  FIRSTPROD:    BOOLEAN;

                  TMPNUM:       INTEGER;

                  PAGE:         INTEGER;
                  LINECOUNT:    INTEGER;
                  FIRSTINCL:    BOOLEAN;

                  STARTPAGE:    INTEGER;
                  VARSTARTPAGE: STRING;

               END;

VAR   logfile:          text;
      ctrlstruct:       CtrlRec;
      s:                STRING;
      opened:           INTEGER;
      glob:             STRING;

FUNCTION ErrorText(i:INTEGER):STRING;
   VAR e: STRING;
   BEGIN
      e:='Unknown error-code';
      CASE i OF
           1: e:='Invalid function number';
           2: e:='File not found';
           3: e:='Path not found';
           4: e:='Too many open files';
           5: e:='File access denied';
           6: e:='Invalid file handle';
          12: e:='Invalid file access code';
          15: e:='Invalid drive number';
          16: e:='Cannot remove current directory';
          17: e:='Cannot rename across drives';
          18: e:='No more files';
         100: e:='Disk read error';
         101: e:='Disk write error';
         102: e:='File not assigned';
         103: e:='File not open';
         104: e:='File not open for input';
         105: e:='File not open for output';
         106: e:='Invalid numeric format';
         150: e:='Disk is write-protected';
         151: e:='Bad drive request struct length';
         152: e:='Drive not ready';
         154: e:='CRC-error in data';
         156: e:='Disk seek error';
         157: e:='Unknow media type';
         158: e:='Sector not found';
         159: e:='Printer out of paper';
         160: e:='Device write fault';
         161: e:='Device read fault';
         162: e:='Hardware failure';
         200: e:='Division by zero';
         201: e:='Range check error';
         202: e:='Stack overflow error';
         203: e:='Heap overflow error';
         204: e:='Invalid pointer operation';
         205: e:='Floating point overflow';
         206: e:='Floating point underflow';
         207: e:='Invalid floating point operation';
         208: e:='Overlay manager not installed';
         209: e:='Overlay files read error';
         210: e:='Object not initialized';
         211: e:='Call to abstract method';
         212: e:='Stream registration error';
         213: e:='Collection index out of range';
         214: e:='Collection overflow error';
         215: e:='Arithmetic overflow error';
         216: e:='General Protection fault';
      END;
      ErrorText:=e;
   END;

FUNCTION Dec2Roman(wo_in : Word) : st_15;
   BEGIN
      Dec2Roman := Thouz[(wo_in div 1000)] +
                   Hunz[((wo_in mod 1000) div 100)] +
                   Tenz[(((wo_in mod 1000) mod 100) div 10)] +
                   Wunz[(((wo_in mod 1000) mod 100) mod 10)];
   END;

FUNCTION RMLTrim(s:STRING):STRING;
   VAR i: INTEGER;
   BEGIN
      WHILE (s[1]=' ') AND (Length(s)>=1) DO
            delete(s,1,1);
      RMLTrim:=s;
   END;

FUNCTION RMRTrim(s:STRING):STRING;
   VAR i: INTEGER;
   BEGIN
      WHILE (Length(s)>=1) AND (s[Length(s)]=' ') DO
            delete(s,Length(s),1);
      RMRTrim:=s;
   END;

FUNCTION RMTrim(s:STRING):STRING;
   BEGIN
      s:=RMLTrim(s);
      s:=RMRTrim(s);
      RMTrim:=s;
   END;

FUNCTION RMright(i,s:INTEGER):STRING;
   VAR y: STRING;
   BEGIN
      STR(i,y);
      y:=space+y;
      RMright:=copy(y,Length(y)-s+1,s);
   END;

PROCEDURE checkIO(code:INTEGER);
   BEGIN
      IF code<>0 THEN
         BEGIN
            WriteLn;
            WriteLn('runtime-error ',code,' (',ErrorText(code),') occured -> program end.');
            WriteLn('file (?)      ',glob);
            Halt(code);
         END;
   END;

PROCEDURE RMassign(VAR f:text;s:STRING);
   BEGIN
      Assign(f,s);
      glob:=s;
   END;

FUNCTION RMrewrite(VAR f:text):LONGINT;
   BEGIN
      {$I-}
      Rewrite(f);
      RMrewrite:=IOResult;
      {$I+}
      INC(opened);
      IF filedebug THEN
         WriteLn('rewrite  no.: ',opened,' name:',glob);
   END;

FUNCTION RMreset(VAR f:text):LONGINT;
   BEGIN
      {$I-}
      Reset(f);
      RMreset:=IOResult;
      {$I+}
      INC(opened);
      IF filedebug THEN
         writeln('reset    no.: ',opened,' name:',glob);
   END;

FUNCTION RMappend(VAR f:text):LONGINT;
   BEGIN
      {$I-}
      Append(f);
      RMappend:=IOResult;
      {$I+}
      INC(opened);
      IF filedebug THEN
         writeln('append   no.: ',opened,' name:',glob);
   END;

FUNCTION RMclose(VAR f:text):LONGINT;
   BEGIN
      {$I-}
      Close(f);
      RMclose:=IOResult;
      {$I+}
      DEC(opened);
      IF filedebug THEN
         writeln('close    no.: ',opened,' name:',glob);
   END;

FUNCTION RMwriteln(VAR f:text;x:STRING):LONGINT;
   BEGIN
      {$I-}
      Writeln(f,x);
      RMwriteln:=IOResult;
      {$I+}
      IF filedebug THEN
         writeln('writeln  no.: ',opened,' name:',glob);
   END;

FUNCTION RMwrite(VAR f:text;x:STRING):LONGINT;
   BEGIN
      {$I-}
      Write(f,x);
      RMwrite:=IOResult;
      {$I+}
      IF filedebug THEN
         writeln('write    no.: ',opened,' name:',glob);
   END;

FUNCTION RMreadln(VAR f:text;VAR x:STRING):LONGINT;
   BEGIN
      {$I-}
      ReadLn(f,x);
      RMreadln:=IOResult;
      {$I+}
      IF filedebug THEN
         writeln('readln   no.: ',opened,' name:',glob);
   END;

FUNCTION RMerase(s:STRING):LONGINT;
   VAR f: text;
   BEGIN
      RMassign(f,s);
      {$I-}
      Erase(f);
      RMerase:=IOResult;
      {$I+}
      IF filedebug THEN
         writeln('erase    no.: ',opened,' name:',glob);
   END;

PROCEDURE ColorWrite1(c1:BYTE;s:STRING;c2:BYTE);
   BEGIN
      TextColor(c1);
      Write(s);
      TextColor(c2);
      Write(logfile,s);
   END;

PROCEDURE ColorWrite2(c1:BYTE;s1:STRING;c2:BYTE;s2:STRING;c3:BYTE);
   BEGIN
      TextColor(c1);
      Write(s1);
      TextColor(c2);
      Write(s2);
      TextColor(c3);
      Write(logfile,s1);
      Write(logfile,s2);
   END;

PROCEDURE ColorWriteLn;
   BEGIN
      WriteLn;
      CheckIO(RMwriteln(logfile,' '));
   END;

FUNCTION Exchange(a:STRING;VAR b:STRING;c:STRING):BOOLEAN;
   (* String A in String B is changed to String C *)
   (* But not, if String A is found in Apostrophes *)
   (* Returncode: TRUE if no more Strings A in String B *)
   (* CAUTION: There could be an endless-Loop if A is included in B *)
   VAR i,j:     INTEGER;
       t1,t2 :  STRING;
       apcount: INTEGER;
   BEGIN
       Exchange:=FALSE;
       i:=POS(a,b);
       IF i>0 THEN
          BEGIN
             apcount:=0;
             FOR j:=1 TO i DO
                IF b[j]=CHR(39) THEN INC(apcount);
             IF (apcount MOD 2) = 0 THEN
                BEGIN
                   (* not in apostrophes -> change *)
                   t1:=copy(b,1,i-1);
                   t2:=copy(b,i+Length(a),Length(b)-i-Length(a)+1);
                   b:=t1+c+t2;
                   ExChange:=TRUE;
                END;
          END;
   END;

FUNCTION WeekDay(year:INTEGER;mon,day:BYTE):INTEGER;
CONST d0 : LONGINT = -428;
VAR   m  : BYTE;
      dn : LONGINT;
BEGIN
   m := mon;
   IF m <= 2 THEN
      BEGIN
         m := m + 12;
         dec(year);
      END;
   dn := d0 + day + TRUNC(30.61 * (m + 1)) + TRUNC(365.25 * year) +
         TRUNC(year / 400) - TRUNC(year / 100) + 15;
   WeekDay:=dn MOD 7 -1;
END;

PROCEDURE ConvertDateN(a:STRING;VAR c:CtrlRec);
   VAR dd, mm, jjjj, code: INTEGER;
   BEGIN
      c.ndate_dd:=copy(a,1,2);
      c.ndate_mm:=copy(a,4,2);
      c.ndate_jjjj:=copy(a,7,4);
      IF Length(c.ndate_jjjj)>2 THEN
         c.ndate_jj:=copy(c.ndate_jjjj,Length(c.ndate_jjjj)-1,2);
      c.ndate_d:=c.ndate_dd;
      IF c.ndate_dd[1]=' ' THEN c.ndate_dd[1]:='0';
      IF c.ndate_d[1]='0' THEN c.ndate_d[1]:=' ';
      c.ndate_m:=c.ndate_mm;
      IF c.ndate_mm[1]=' ' THEN c.ndate_mm[1]:='0';
      IF c.ndate_m[1]='0' THEN c.ndate_m[1]:=' ';
      Val(c.ndate_dd,dd,code);
      Val(c.ndate_mm,mm,code);
      Val(c.ndate_jjjj,jjjj,code);
      c.ndate_mmm:=copy(c.months,1+(mm-1)*3,3);
      c.ndate_wd:=copy(c.weekdays,1+Weekday(jjjj,mm,dd)*2,2);
   END;

PROCEDURE ConvertDateA(VAR c:CtrlRec);
   BEGIN
      STR(c.idate_dd,c.adate_d);
      IF c.idate_dd<10 THEN
         BEGIN
            c.adate_dd:='0'+c.adate_d;
            c.adate_d:=' '+c.adate_d;
         END
      ELSE
         c.adate_dd:=c.adate_d;
      STR(c.idate_mm,c.adate_m);
      IF c.idate_mm<10 THEN
         BEGIN
            c.adate_mm:='0'+c.adate_m;
            c.adate_m:=' '+c.adate_m;
         END
      ELSE
         c.adate_mm:=c.adate_m;
      c.adate_mmm:=copy(c.months,1+(c.idate_mm-1)*3,3);
      STR(c.idate_jjjj,c.adate_jjjj);
      IF c.idate_jjjj>2 THEN
         c.adate_jj:=copy(c.adate_jjjj,Length(c.adate_jjjj)-1,2);
      c.adate_wd:=copy(c.weekdays,1+c.idate_wd*2,2);
   END;

FUNCTION WorkUp(a:STRING):STRING;
   VAR i:       INTEGER;
       apcount: INTEGER;
       n:       STRING;
   BEGIN
      n:='';
      apcount:=0;
      FOR i:=1 TO Length(a) DO
         BEGIN
            IF a[i]=CHR(39) THEN
               INC(apcount);
            IF (apcount MOD 2) = 0 THEN
               (* not in apostrophes *)
               BEGIN
                  IF a[i]=';' THEN
                     (* ignore everything after a ';' and ';' itself *)
                     i:=Length(a)
                  ELSE
                     IF a[i]<>' ' THEN
                        n:=n+Upcase(a[i]);
               END;
            IF (apcount MOD 2) = 1 THEN
               (* in apostrophes *)
               n:=n+a[i];
         END;
      IF (n[1]='/') AND (n[2]='/') THEN
         (* Comments *)
         n:='';
      WorkUp:=n;
   END;

PROCEDURE ColorWriteLnZ(c1:INTEGER;a:STRING;c2:INTEGER;b:STRING;c3:INTEGER);
   VAR t: STRING;
       i: INTEGER;
       f: BOOLEAN;
   BEGIN
      f:=TRUE;
      b:=b+' ';
      REPEAT
         i:=POS(' ',b);
         if i>0 THEN
            BEGIN
               t:=copy(b,1,i);
               b:=copy(b,i+1,254);
            END;
         IF f THEN
            BEGIN
               ColorWrite2(c1,a,c2,t,c3);
               ColorWriteLn;
               f:=FALSE;
            END
         ELSE
            BEGIN
               ColorWrite2(c1,copy(space,1,Length(a)),c2,t,c3);
               ColorWriteLn;
            END;
      UNTIL POS(' ',b)<=0;
   END;

PROCEDURE WriteCtrlRec(c:CtrlRec);
   VAR c1: INTEGER;
       c2: INTEGER;
       c3: INTEGER;
       x:  STRING;
   BEGIN
      c1:=LightCyan;
      c2:=White;
      c3:=White;
      ColorWriteLn;
      ColorWrite2(c1,'default Months ........... ',c2,c.MONTHS,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default Weekdays ......... ',c2,c.WEEKDAYS,c3);
      ColorWriteLn;
      STR(c.VOLUME,x);
      ColorWrite2(c1,'default Volume ........... ',c2,x,c3);
      ColorWriteLn;
      STR(c.ISSUE,x);
      ColorWrite2(c1,'default Issue ............ ',c2,x,c3);
      ColorWriteLn;
      STR(c.STARTPAGE,x);
      ColorWrite2(c1,'default StartPage ........ ',c2,x,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default var.StartPage .... ',c2,c.VARSTARTPAGE,c3);
      ColorWriteLn;
      STR(c.PAGELENGTH,x);
      ColorWrite2(c1,'default Pagelength ....... ',c2,x,c3);
      ColorWriteLn;
      STR(c.OFFSET,x);
      ColorWrite2(c1,'default Offset ........... ',c2,x,c3);
      ColorWriteLn;
      STR(c.WIDTH,x);
      ColorWrite2(c1,'default Width ............ ',c2,x,c3);
      ColorWriteLn;
      STR(c.TOCLINES,x);
      ColorWrite2(c1,'default eff.TOC-Lines .... ',c2,x,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default TOC-FillChar ..... ',c2,c.TOCFILLCHAR,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default Tic-Area ......... ',c2,c.TICAREA,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default Tic-Area-Desc. ... ',c2,c.TICAREAD,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default Tic-Password ..... ',c2,c.TICPASSWD,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default Tic-Own-Addr ..... ',c2,c.TICOWN,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default Tic-Desc ......... ',c2,c.TICDESC,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default BreakSign ........ ',c2,c.BREAKSIGN,c3);
      ColorWriteLn;

      ColorWrite2(c1,'default $ADATE-D ......... ',c2,c.adate_d,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-DD ........ ',c2,c.adate_dd,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-M ......... ',c2,c.adate_m,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-MM ........ ',c2,c.adate_mm,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-MMM ....... ',c2,c.adate_mmm,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-YY ........ ',c2,c.adate_jj,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-YYYY ...... ',c2,c.adate_jjjj,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ADATE-WD ........ ',c2,c.adate_wd,c3);
      ColorWriteLn;

      ColorWrite2(c1,'default $NDATE-D ......... ',c2,c.ndate_d,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-DD ........ ',c2,c.ndate_dd,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-M ......... ',c2,c.ndate_m,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-MM ........ ',c2,c.ndate_mm,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-MMM ....... ',c2,c.ndate_mmm,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-YY ........ ',c2,c.ndate_jj,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-YYYY ...... ',c2,c.ndate_jjjj,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NDATE-WD ........ ',c2,c.ndate_wd,c3);
      ColorWriteLn;

      ColorWrite2(c1,'default $HNAME ........... ',c2,c.HNAME,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $VOLUMEF ......... ',c2,c.VOLUMEF,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $VOLUMEH ......... ',c2,c.VOLUMEH,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ISSUEF .......... ',c2,c.ISSUEF,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $NEWS ............ ',c2,c.NEWS,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ISSUEDIR ........ ',c2,c.ISSUEDIR,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $INCLUDEDIR ...... ',c2,c.INCLUDEDIR,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $TEXTFILE ........ ',c2,c.TEXTFILE,c3);
      ColorWriteLn;
      ColorWrite2(c1,'default $ARCNAME ......... ',c2,c.ARCNAME,c3);
      ColorWriteLn;
      ColorWriteLnZ(c1,'default $PACKCOMMAND ..... ',c2,c.PACKCOMMAND,c3);
      ColorWriteLn;
   END;

PROCEDURE ConvertVolume(a:INTEGER;VAR b,c:STRING);
   BEGIN
      IF a<10 THEN
         BEGIN
            STR(a,c);
            b:='0'+c;
         END
      ELSE
         BEGIN
            STR(a,b);
            c:=CHR(ORD('A')-10+a);
         END;
   END;

PROCEDURE ConvertIssue(a:INTEGER;VAR b:STRING);
   BEGIN
      IF a<10 THEN
         BEGIN
            STR(a,b);
            b:='0'+b;
         END
      ELSE
         BEGIN
            STR(a,b);
         END;
   END;

FUNCTION KeyWord(a:STRING):STRING;
   VAR i: INTEGER;
   BEGIN
      i:=POS('=',a);
      IF i>=2 THEN
         KeyWord:=copy(a,1,i-1)
      ELSE
         KeyWord:='./.';
   END;

FUNCTION Argument(a:STRING):STRING;
   VAR i: INTEGER;
       n: STRING;
       m: STRING;
   BEGIN
      i:=POS('=',a);
      IF i>=2 THEN
         BEGIN
            n:=copy(a,i+1,Length(a)-i);
            m:='';
            FOR i:=1 TO Length(n) DO
               IF n[i]<>CHR(39) THEN
                  m:=m+n[i];
         END
      ELSE
         m:='./.';
      Argument:=m;
   END;

FUNCTION ResolvePage(a:STRING;c:CtrlRec):STRING;
   VAR s: STRING;
       t: STRING;
       v: STRING;
   BEGIN
      STR(c.page,s);
      STR(c.page+1,t);
      s:=s+space;
      s:=copy(s,1,4);
      t:=t+space;
      t:=copy(t,1,4);
      v:=Dec2Roman(c.page);
      v:=v+space;
      v:=copy(v,1,15);
      WHILE ExChange('$PAGE',a,s) DO;
      WHILE ExChange('$NPAGE',a,t) DO;
      WHILE ExChange('$RPAGE',a,v) DO;
      ResolvePage:=a;
   END;

FUNCTION Resolve(a:STRING;c:CtrlRec):STRING;
   VAR s: STRING;
   BEGIN
      WHILE ExChange('$ADATE-DD',a,c.adate_dd) DO;
      WHILE ExChange('$ADATE-D',a,c.adate_d) DO;
      WHILE ExChange('$ADATE-MMM',a,c.adate_mmm) DO;
      WHILE ExChange('$ADATE-MM',a,c.adate_mm) DO;
      WHILE ExChange('$ADATE-M',a,c.adate_m) DO;
      WHILE ExChange('$ADATE-YYYY',a,c.adate_jjjj) DO;
      WHILE ExChange('$ADATE-YY',a,c.adate_jj) DO;
      WHILE ExChange('$ADATE-WD',a,c.adate_wd) DO;
      WHILE ExChange('$NDATE-DD',a,c.ndate_dd) DO;
      WHILE ExChange('$NDATE-D',a,c.ndate_d) DO;
      WHILE ExChange('$NDATE-MMM',a,c.ndate_mmm) DO;
      WHILE ExChange('$NDATE-MM',a,c.ndate_mm) DO;
      WHILE ExChange('$NDATE-M',a,c.ndate_m) DO;
      WHILE ExChange('$NDATE-YYYY',a,c.ndate_jjjj) DO;
      WHILE ExChange('$NDATE-YY',a,c.ndate_jj) DO;
      WHILE ExChange('$NDATE-WD',a,c.ndate_wd) DO;
      WHILE ExChange('$HNAME',a,c.hname) DO;
      WHILE ExChange('$VOLUMEF',a,c.volumef) DO;
      WHILE ExChange('$VOLUMEH',a,c.volumeh) DO;
      WHILE ExChange('$ISSUEF',a,c.issuef) DO;
      WHILE ExChange('$NEWS',a,c.news) DO;
      WHILE ExChange('$ISSUEDIR',a,c.issuedir) DO;
      WHILE ExChange('$INCLUDEDIR',a,c.includedir) DO;
      WHILE ExChange('$TEXTFILE',a,c.textfile) DO;
      WHILE ExChange('$ARCNAME',a,c.arcname) DO;
      WHILE ExChange('$PACKCOMMAND',a,c.packcommand) DO;
      WHILE ExChange('$SECNAME',a,c.secname) DO;
      a:=ResolvePage(a,c);
      Resolve:=a;
   END;

FUNCTION LookForFile(n:STRING):LONGINT;
   VAR f: text;
       x: LONGINT;
   BEGIN
      RMassign(f,n);
      LookForFile:=RMreset(f);
      x:=RMclose(f);
   END;

FUNCTION FL(s:STRING;VAR c:CtrlRec):STRING;
   (* FormLine *)
   VAR u,v,w,x: STRING;
   BEGIN
      u:=copy(space,1,c.offset);      (* left part *)
      v:=Resolve(s,c);                (* middle part *)
      (*  debugging code
      Str(c.linecount,x);
      x:=space+x;
      Str(c.anoofiss,w);
      x:=' '+copy(x,length(x)-3+1,3);
      FL:=u+v+copy(space+space,1,85-length(u+v))+w+' '+x;
      *)
      FL:=u+v;
      INC(c.linecount);
   END;

PROCEDURE WriteHeader(VAR aus:text;VAR c:CtrlRec);
   VAR ein: text;
       buf: STRING;
   BEGIN
      IF c.headincl<>'' THEN
         BEGIN
            RMassign(ein,c.headincl);
            CheckIO(RMreset(ein));
            IF NOT EOF(ein) THEN
               BEGIN
                  CheckIO(RMreadln(ein,buf));
                  CheckIO(RMWrite(aus,ff));
                  CheckIO(RMwriteln(aus,FL(buf,c)));
               END;
            WHILE NOT EOF(ein) DO
               BEGIN
                  CheckIO(RMreadln(ein,buf));
                  CheckIO(RMwriteln(aus,FL(buf,c)));
               END;
            CheckIO(RMclose(ein));
         END;
   END;

PROCEDURE WriteBanner(VAR aus:text;VAR c:CtrlRec);
   VAR ein: text;
       buf: STRING;
   BEGIN
      IF c.bannincl<>'' THEN
         BEGIN
            RMassign(ein,c.bannincl);
            CheckIO(RMreset(ein));
            WHILE NOT EOF(ein) DO
               BEGIN
                  CheckIO(RMreadln(ein,buf));
                  CheckIO(RMwriteln(aus,FL(buf,c)));
               END;
            CheckIO(RMclose(ein));
         END;
   END;

PROCEDURE WriteFooter(VAR aus:text;VAR c:CtrlRec);
   VAR ein: text;
       buf: STRING;
   BEGIN
      IF c.footincl<>'' THEN
         BEGIN
            RMassign(ein,c.footincl);
            CheckIO(RMreset(ein));
            WHILE NOT EOF(ein) DO
               BEGIN
                  CheckIO(RMreadln(ein,buf));
                  CheckIO(RMwriteln(aus,FL(buf,c)));
               END;
            CheckIO(RMclose(ein));
         END;
   END;

PROCEDURE WriteBreak(VAR aus:text;VAR c:CtrlRec);
   VAR ein: text;
       buf: STRING;
       ofs: INTEGER;
   BEGIN
       IF c.linecount<(c.pagelength-3) THEN
          BEGIN
             (* not to overflow the pagelength *)
             CheckIO(RMwriteln(aus,FL(' ',c)));
             ofs:=(c.width-length(c.breaksign)) DIV 2;
             buf:=copy(space,1,ofs)+c.breaksign;
             CheckIO(RMwriteln(aus,FL(buf,c)));
             CheckIO(RMwriteln(aus,FL(' ',c)));
          END;
   END;

PROCEDURE IncludeFile(s:STRING;VAR c: CtrlRec);
   VAR st:  STRING;
       aus: text;
       ein: text;
       buf: STRING;
       x,y: STRING;
   BEGIN
      IF c.tocwas=After THEN
         BEGIN
            st:=c.afttoc;
         END
      ELSE
         BEGIN
            st:=c.beftoc;
         END;
      (*
      ColorWrite2(DarkGray,'   From: ',DarkGray,s,White);
      ColorWriteLn;
      ColorWrite2(DarkGray,'   To:   ',DarkGray,st,White);
      ColorWriteLn;
      *)
      {$I-}
      IF LookForFile(st)<>0 THEN
         BEGIN
            RMassign(aus,st);
            CheckIO(RMrewrite(aus));
         END
      ELSE
         BEGIN
            RMassign(aus,st);
            CheckIO(RMAppend(aus));
         END;
      RMassign(ein,s);
      CheckIO(RMreset(ein));
      INC(c.anoofiss);
      WHILE NOT EOF(ein) DO
         BEGIN
            CheckIO(RMreadln(ein,buf));
            IF c.footincl<>'' THEN
               IF c.linecount > (c.pagelength-c.footleng) THEN
                  WriteFooter(aus,c);
            IF c.linecount > c.pagelength THEN
               BEGIN
                  IF (c.tocwas=After) OR (c.tocwas=Now) THEN
                     INC(c.page);
                  c.linecount:=0;
               END;
            IF c.linecount=0 THEN
               BEGIN
                  (* Header include *)
                  WriteHeader(aus,c);
                  IF c.firstincl THEN
                     BEGIN
                        c.firstincl:=FALSE;
                        WriteBanner(aus,c);
                     END;
               END;
            IF Length(buf)>c.width THEN
               BEGIN
                  STR(Length(buf),x);
                  STR(c.width,y);
                  ColorWrite2(Red,'*** Warning ***',White,' Line to long: ('+x+' greater '+y+') ',White);
                  ColorWriteLn;
                  ColorWrite1(White,copy(buf,1,60),White);
                  ColorWriteLn;
               END;
            CheckIO(RMwriteln(aus,FL(buf,c)));
         END;
      IF c.anoofiss<>c.noofiss THEN
         (* After last submission in this section: no break *)
         (* but a footer *)
         IF c.break_np=Break THEN
            (* In this section: after each submission -> BreakSign *)
            WriteBreak(aus,c)
         ELSE
            IF c.break_np=NewPage THEN
            (* In this section: after each submission -> NewPage *)
               BEGIN
                  WriteFooter(aus,c);
                  IF (c.tocwas=After) OR (c.tocwas=Now) THEN
                    INC(c.page);
                  c.linecount:=0;
               END;
      IF c.anoofiss=c.noofiss THEN
         BEGIN
            (* After last submission in this section: everytime a footer
               and a NewPage *)
            WriteFooter(aus,c);
            IF (c.tocwas=After) OR (c.tocwas=Now) THEN
               INC(c.page);
            c.linecount:=0;
         END;
      CheckIO(RMclose(aus));
      CheckIO(RMclose(ein));
      {$I+}
   END;

FUNCTION GetFootLength(VAR c:CtrlRec):INTEGER;
   VAR h: text;
       x: INTEGER;
       s: STRING;
   BEGIN
      RMassign(h,c.footincl);
      CheckIO(RMreset(h));
      x:=0;
      WHILE NOT EOF(h) DO
         BEGIN
            CheckIO(RMreadln(h,s));
            INC(x);
         END;
      GetFootLength:=x;
      CheckIO(RMclose(h));
   END;

PROCEDURE GetHBFPathes(what:CHAR;VAR c:CtrlRec);
   VAR x:  LONGINT;
       st: STRING;

   PROCEDURE H(s:STRING;VAR c:CtrlRec);
      BEGIN
         x:=LookForFile(s);
         STR(x,st);
         IF x=0 THEN
            BEGIN
               ColorWrite2(White,c_h_name,LightGreen,s+' ('+st+')',White);
               ColorWriteLn;
               c.headincl:=s;
            END
         ELSE
            BEGIN
               (*
               ColorWrite2(White,c_h_name,LightRed,s+' ('+st+')',White);
               ColorWriteLn;
               *)
            END;
      END;

   PROCEDURE B(s:STRING;VAR c:CtrlRec);
      BEGIN
         x:=LookForFile(s);
         STR(x,st);
         IF x=0 THEN
            BEGIN
               ColorWrite2(White,c_b_name,LightGreen,s+' ('+st+')',White);
               ColorWriteLn;
               c.bannincl:=s;
            END
         ELSE
            BEGIN
               (*
               ColorWrite2(White,c_b_name,LightRed,s+' ('+st+')',White);
               ColorWriteLn;
               *)
            END;
      END;

   PROCEDURE F(s:STRING;VAR c:CtrlRec);
      BEGIN
         x:=LookForFile(s);
         STR(x,st);
         IF x=0 THEN
            BEGIN
               ColorWrite2(White,c_f_name,LightGreen,s+' ('+st+')',White);
               ColorWriteLn;
               c.footincl:=s;
            END
         ELSE
            BEGIN
               (*
               ColorWrite2(White,c_f_name,LightRed,s+' ('+st+')',White);
               ColorWriteLn;
               *)
            END;
      END;

   BEGIN
      CASE what OF
        'H': BEGIN
               (* H=Header *)
                ColorWrite2(White,c_h_look1,Yellow,c_h_look2,White);
                ColorWriteLn;
                c.headincl:='';
                H(c.headpath1,c);
                IF c.headincl='' THEN
                   H(c.headpath2,c);
                IF c.headincl='' THEN
                   H(c.headpath3,c);
                IF c.headincl='' THEN
                   BEGIN
                      ColorWrite1(LightRed,c_h_nohead,White);
                      ColorWriteLn;
                   END;
             END;
        'B': BEGIN
               (* B=Banner *)
                ColorWrite2(White,c_b_look1,Yellow,c_b_look2,White);
                ColorWriteLn;
                c.bannincl:='';
                B(c.bannpath1,c);
                IF c.bannincl='' THEN
                   B(c.bannpath2,c);
                IF c.bannincl='' THEN
                   B(c.bannpath3,c);
                IF c.bannincl='' THEN
                   BEGIN
                      ColorWrite1(LightRed,c_b_nobann,White);
                      ColorWriteLn;
                   END;
                IF c.secshort='BEG' THEN
                   c.bannincl:='';
             END;
        'F': BEGIN
               (* H=Footer *)
                ColorWrite2(White,c_f_look1,Yellow,c_f_look2,White);
                ColorWriteLn;
                c.footincl:='';
                F(c.footpath1,c);
                IF c.footincl='' THEN
                   F(c.footpath2,c);
                IF c.footincl='' THEN
                   F(c.footpath3,c);
                IF c.footincl='' THEN
                   BEGIN
                      ColorWrite1(LightRed,c_f_nofoot,White);
                      ColorWriteLn;
                   END
                ELSE
                   c.footleng:=GetFootLength(c);
                  (* neccesary for correct pagelength *)
             END;
      END;
   END;

(* For Debugging purposes:
PROCEDURE OutListOfIncludes(f:INCPointerType);
   VAR actINCP: INCPointerType;
       count:   INTEGER;
       x:       STRING;
   BEGIN
      actINCP:=f;
      count:=1;
      WHILE actINCP<>NIL DO
         BEGIN
            Str(count,x);
            ColorWrite1(Yellow,x+' '+actINCP^.ipath,White);
            ColorWriteLn;
            actINCP:=actINCP^.next;
            INC(count);
         END;
   END;
*)

FUNCTION MakeListOfIncludes(VAR c:CtrlRec): INCPointerType;
   VAR s:       SearchRec;
       x:       INTEGER;
       dir:     dirstr;
       name:    namestr;
       ext:     extstr;
       nxtINCP: INCPointerType;
       firINCP: INCPointerType;
       actINCP: INCPointerType;
       oldINCP: INCPointerType;

   FUNCTION newitem(s:STRING;x:INCPointerType):INCPointerType;
      VAR newINCP: INCPointerType;
      BEGIN

         new(newINCP);
         newINCP^.ipath:=s;
         newINCP^.next:=x;
         newitem:=newINCP;
      END;

   BEGIN
      FindFirst(c.issfiles,AnyFile AND (NOT Directory),s);
      x:=DosError;
      firINCP:=NIL;
      oldINCP:=NIL;
      c.noofiss:=0;
      WHILE x=0 DO
         BEGIN
            (* Some matching files found *)
            FSplit(c.issfiles,dir,name,ext);
            (* Create new list element *)
            IF firINCP=NIL THEN
               BEGIN
                  firINCP:=newitem(dir+s.name,NIL);
                  INC(c.noofiss);
               END
            ELSE
               BEGIN
                  actINCP:=firINCP;
                  WHILE (actINCP<>NIL) AND (actINCP^.ipath<dir+s.name) DO
                     BEGIN
                        oldINCP:=actINCP;
                        actINCP:=actINCP^.next;
                     END;
                  IF (actINCP<>NIL) AND (actINCP^.ipath>=dir+s.name) THEN
                     BEGIN
                        oldINCP^.next:=newitem(dir+s.name,actINCP);
                        INC(c.noofiss);
                     END;
                  if actINCP=NIL THEN
                     BEGIN
                        oldINCP^.next:=newitem(dir+s.name,NIL);
                        INC(c.noofiss);
                     END;
               END;
            FindNext(s);
            x:=DosError;
         END;
         MakeListOfIncludes:=firINCP;
   END;

PROCEDURE IncludeIndex(s:STRING;VAR c:CtrlRec);
   (* Writes First c.toclines Star-Lines of a submission to TEMP.TOC *)
   VAR t:          text;
       x:          STRING;
       i:          INTEGER;
       y:          STRING;
       p:          STRING;
   BEGIN
      RMassign(t,s);
      CheckIO(RMreset(t));
      FOR i:=1 TO c.toclines DO
         BEGIN
            CheckIO(RMreadln(t,x));
            IF x[1]='*' THEN
               BEGIN
                  CASE i OF
                     1: BEGIN
                           y:='    ';
                           y:=y+RMTrim(copy(x,2,99))+'  ';
                           y:=copy(y+c.tocfil,1,c.width-c.offset-4-4)+' ';
                           STR(c.page,p);
                           y:=y+p;
                        END;
                     ELSE
                        BEGIN
                           y:='       ';
                           y:=y+RMTrim(copy(x,2,99));
                           y:=copy(y+space+space,1,c.width-c.offset-4-4);
                        END;
                  END;
                  IF RMTrim(y)<>'' THEN
                     CheckIO(RMwriteln(c.tochandle,y));
               END;
         END;
      CheckIO(RMclose(t));
   END;

PROCEDURE ReadIncludes(VAR c:CtrlRec);
   VAR aINCP:  INCPointerType;
       x:      STRING;
   BEGIN
      c.firstincl:=TRUE;
      c.linecount:=0;
      IF c.secflag='#' THEN
         ColorWrite2(White,c_s_look1,Yellow,c_s_look2a,White)
      ELSE
         ColorWrite2(White,c_s_look1,Yellow,c_s_look2b,White);
      STR(c.noofiss,x);
      ColorWrite1(Yellow,' ('+x+')',White);
      ColorWriteLn;
      IF c.secflag='#' THEN
         ColorWrite2(White,c_s_path,White,c.issfiles,White)
      ELSE
         ColorWrite2(White,c_s_pathna,White,c.issfiles,White);
      ColorWriteLn;
      IF c.fINCP=NIL THEN
         (* didn't find any file *)
         BEGIN
            ColorWrite2(White,c_s_incln,LightRed,c.issfiles,White);
            ColorWriteLn;
         END
      ELSE
         BEGIN
            aINCP:=c.fINCP;
            WHILE aINCP<>NIL DO
               BEGIN
                  ColorWrite2(White,c_s_inclfb,LightGreen,aINCP^.ipath,White);
                  ColorWriteLn;
                  IncludeIndex(aINCP^.ipath,c);
                  IncludeFile(aINCP^.ipath,c);
                  aINCP:=aINCP^.next;
               END;
         END;
   END;

PROCEDURE Formatter(s:STRING;VAR c: CtrlRec);
   VAR i:                       INTEGER;
       sn:                      STRING;
       sh:                      STRING;
       iss:                     BOOLEAN;
       inds:                    STRING;
       pag:                     STRING;
   BEGIN
      i:=POS(',',s);
      IF i>1 THEN
         (* 1. parameter is filename for include *)
         (* 2. parameter is sectionname for TOC *)
         BEGIN
            sh:=copy(s,1,i-1);
            c.secname:=copy(s,i+1,Length(s)-(i+1)+1);
         END
      ELSE
         BEGIN
            sh:=s;
            c.secname:='[no name]';
         END;
      IF (sh[1]='#') AND (Length(sh)<>4) THEN
         BEGIN
            writeln('*** syntax-error: line doesn'+CHR(39)+'t match PRODUCE=#xxx ***');
            Halt(1);
         END;
      IF (sh[1]='!') AND (Length(sh)<>4) THEN
         BEGIN
            writeln('*** syntax-error: line doesn'+CHR(39)+'t match PRODUCE=!xxx ***');
            Halt(1);
         END;
      c.secflag:=' ';
      c.secshort:='';
      IF (sh[1]='#') OR (sh[1]='!') THEN
         BEGIN
            c.secflag:=sh[1];
            c.secshort:=copy(sh,2,3);
         END;
      IF c.secflag=' ' THEN
         BEGIN
            writeln('*** syntax-error: line doesn'+CHR(39)+'t match PRODUCE=[!|#]xxx ***');
            Halt(1);
         END;
      (* First priority definitions *)
      c.headpath1:=c.issuedir+'\'+c.secshort+'.HED';
      c.bannpath1:=c.issuedir+'\'+c.secshort+'.BAN';
      c.footpath1:=c.issuedir+'\'+c.secshort+'.FOT';
      (* Second priority definitions *)
      c.headpath2:=c.includedir+'\'+c.secshort+'.HED';
      c.bannpath2:=c.includedir+'\'+c.secshort+'.BAN';
      c.footpath2:=c.includedir+'\'+c.secshort+'.FOT';
      (* Third priority definitions *)
      c.headpath3:=c.includedir+'\'+c.news+'.HED';
      c.bannpath3:=c.includedir+'\'+c.news+'.BAN';
      c.footpath3:=c.includedir+'\'+c.news+'.FOT';
      IF c.secflag='#' THEN
         c.issfiles :=c.issuedir+'\*.'+c.secshort;
      IF c.secflag='!' THEN
         c.issfiles :=c.includedir+'\'+c.news+'.'+c.secshort;
      ColorWriteln;
      ColorWrite2(White,c_sectionf,LightCyan,c.secshort+' - ',White);
      ColorWrite1(LightCyan,c.secname,White);
      IF (c.secshort='BEG') OR (c.secshort='TOC') THEN
         Colorwrite1(LightCyan,' [special function]',White);
      IF c.break_np=Break THEN
         Colorwrite1(LightCyan,' [with breaks]',White);
      IF c.break_np=NewPage THEN
         Colorwrite1(LightCyan,' [with newpages]',White);
      ColorWriteln;
      c.fINCP:=MakeListOfIncludes(c);
      c.anoofiss:=0;
      IF c.fINCP<>NIL THEN
         BEGIN
            GetHBFPathes('H',c);
            GetHBFPathes('B',c);
            GetHBFPathes('F',c);
         END;
      IF (c.secshort='TOC') AND (c.secflag='!') THEN
         c.tocwas:=After
      ELSE
         IF c.fINCP=NIL THEN
            (* no Includes for this section, only a hint *)
            ReadIncludes(c)
         ELSE
            BEGIN
               IF c.secshort<>'TOC' THEN
                  BEGIN
                    IF c.secname<>'[no name]' THEN
                       BEGIN
                          INC(c.secnum);
                          inds:=RMright(c.secnum,2)+'. '+c.secname+'  ';
                          inds:=copy(inds+c.tocfil,1,c.width-c.offset-4-4)+' ';
                          STR(c.page,pag);
                          inds:=inds+pag;
                          CheckIO(RMwriteln(c.tochandle,inds));
                       END;
                     ReadIncludes(c);
                  END;
            END;
   END;

PROCEDURE ChangeConfig(VAR c:CtrlRec;a:STRING);
   VAR Key:     STRING;
       code:    WORD;
       sec:     STRING;
       temptoc: text;
       x:       LONGINT;
       c1:      INTEGER;
       c2:      INTEGER;
       c3:      INTEGER;
       y:       STRING;
       D:       DirStr;
       N:       NameStr;
       E:       ExtStr;
   BEGIN
      c1:=Yellow;
      c2:=White;
      c3:=White;
      Key:=Keyword(a);
      IF Key='MONTHS' THEN
         BEGIN
            c.months:=Argument(a);
            ColorWrite2(c1,'changed Months ........... ',c2,c.MONTHS,c3);
            ColorWriteLn;
         END;
      IF Key='WEEKDAYS' THEN
         BEGIN
            c.weekdays:=Argument(a);
            ColorWrite2(c1,'changed Weekdays ......... ',c2,c.WEEKDAYS,c3);
            ColorWriteLn;
         END;
      IF Key='DATE' THEN
         BEGIN
            ConvertDateN(Argument(a),c);
            ColorWrite2(c1,'changed $NDATE-D ......... ',c2,c.ndate_d,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-DD ........ ',c2,c.ndate_dd,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-M ......... ',c2,c.ndate_m,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-MM ........ ',c2,c.ndate_mm,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-MMM ....... ',c2,c.ndate_mmm,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-YY ........ ',c2,c.ndate_jj,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-YYYY ...... ',c2,c.ndate_jjjj,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $NDATE-WD ........ ',c2,c.ndate_wd,c3);
            ColorWriteLn;
         END;
      IF Key='HNAME' THEN
         BEGIN
            c.hname:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed $HNAME ........... ',c2,c.HNAME,c3);
            ColorWriteLn;
         END;
      IF Key='VOLUME' THEN
         BEGIN
            VAL(Argument(a),c.volume,code);
            ConvertVolume(c.volume,c.volumef,c.volumeh);
            ColorWrite2(c1,'changed $VOLUMEF ......... ',c2,c.VOLUMEF,c3);
            ColorWriteLn;
            ColorWrite2(c1,'changed $VOLUMEH ......... ',c2,c.VOLUMEH,c3);
            ColorWriteLn;
            c.ticdesc:='FidoNews volume '+c.volumef+' issue '+c.issuef+', '+c.adate_jjjj;
         END;
      IF Key='ISSUE' THEN
         BEGIN
            VAL(Argument(a),c.issue,code);
            ConvertIssue(c.issue,c.issuef);
            ColorWrite2(c1,'changed $ISSUEF .......... ',c2,c.ISSUEF,c3);
            ColorWriteLn;
            c.ticdesc:='FidoNews volume '+c.volumef+' issue '+c.issuef+', '+c.adate_jjjj;
         END;
      IF Key='STARTPAGE' THEN
         BEGIN
            VAL(Argument(a),c.startpage,code);
            IF c.startpage=0 THEN
               c.startpage:=1;
            c.page:=c.startpage;
            STR(c.startpage,y);
            ColorWrite2(c1,'changed StartPage ........ ',c2,y,c3);
            ColorWriteLn;
         END;
      IF Key='VAR-STARTPAGE' THEN
         BEGIN
            c.varstartpage:=Resolve(Argument(a),c);
            IF (c.varstartpage[1]='Y') or (c.varstartpage[1]='y') THEN
               c.varstartpage:='Y'
            ELSE
               c.varstartpage:='N';
            ColorWrite2(c1,'changed var.Startpage .... ',c2,c.varstartpage,c3);
            ColorWriteLn;
         END;
      IF Key='NEWS' THEN
         BEGIN
            c.news:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed $NEWS ............ ',c2,c.NEWS,c3);
            ColorWriteLn;
         END;
      IF Key='ISSUEDIR' THEN
         BEGIN
            c.issuedir:=Resolve(Argument(a),c);
            c.beftoc:=c.issuedir+'\'+'TEMP.BT';
            c.afttoc:=c.issuedir+'\'+'TEMP.AT';
            c.tocname:=c.issuedir+'\'+'TEMP.TOC';
            ColorWrite2(c1,'changed $ISSUEDIR ........ ',c2,c.ISSUEDIR,c3);
            ColorWriteLn;
         END;
      IF Key='INCLUDEDIR' THEN
         BEGIN
            c.includedir:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed $INCLUDEDIR ...... ',c2,c.INCLUDEDIR,c3);
            ColorWriteLn;
         END;
      IF Key='TEXTFILE' THEN
         BEGIN
            c.textfile:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed $TEXTFILE ........ ',c2,c.TEXTFILE,c3);
            ColorWriteLn;
         END;
      IF Key='ARCNAME' THEN
         BEGIN
            c.arcname:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed $ARCNAME ......... ',c2,c.ARCNAME,c3);
            FSplit(c.ARCNAME, D, N, E);
            c.ticpath:=D;
            ColorWriteLn;
         END;
      IF Key='PACKCOMMAND' THEN
         BEGIN
            c.packcommand:=Resolve(Argument(a),c);
            ColorWriteLnZ(c1,'changed $PACKCOMMAND ..... ',c2,c.PACKCOMMAND,c3);
         END;
      IF Key='PAGELENGTH' THEN
         BEGIN
            VAL(Argument(a),c.pagelength,code);
            c.pagelength:=c.pagelength-1;  (* start with 0 *)
            STR(c.pagelength,y);
            ColorWrite2(c1,'changed PageLength ....... ',c2,y,c3);
            ColorWriteLn;
         END;
      IF Key='OFFSET' THEN
         BEGIN
            VAL(Argument(a),c.offset,code);
            STR(c.offset,y);
            ColorWrite2(c1,'changed Offset ........... ',c2,y,c3);
            ColorWriteLn;
         END;
      IF Key='WIDTH' THEN
         BEGIN
            VAL(Argument(a),c.width,code);
            STR(c.width,y);
            ColorWrite2(c1,'changed Width ............ ',c2,y,c3);
            ColorWriteLn;
         END;
      IF Key='TOCLINES' THEN
         BEGIN
            VAL(Argument(a),c.toclines,code);
            STR(c.toclines,y);
            ColorWrite2(c1,'changed eff.TOC-Lines .... ',c2,y,c3);
            ColorWriteLn;
         END;
      IF Key='TOCFILLCHAR' THEN
         BEGIN
            c.tocfillchar:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed TOC-FillChar ..... ',c2,c.TOCFILLCHAR,c3);
            ColorWriteLn;
            c.tocfil:='';
            WHILE Length(c.tocfil)<80 DO
               c.tocfil:=c.tocfil+c.tocfillchar;
         END;
      IF Key='TICAREA' THEN
         BEGIN
            c.ticarea:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed Tic-Area ......... ',c2,c.TICAREA,c3);
            ColorWriteLn;
         END;
      IF Key='TICAREAD' THEN
         BEGIN
            c.ticaread:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed Tic-Areadesc ..... ',c2,c.TICAREAD,c3);
            ColorWriteLn;
         END;
      IF Key='TICPASSWD' THEN
         BEGIN
            c.ticpasswd:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed Tic-Password ..... ',c2,c.TICPASSWD,c3);
            ColorWriteLn;
         END;
      IF Key='TICOWN' THEN
         BEGIN
            c.ticown:=Argument(a);
            ColorWrite2(c1,'changed Tic-Own-Addr ..... ',c2,c.TICOWN,c3);
            ColorWriteLn;
         END;
      IF Key='TICDESC' THEN
         BEGIN
            c.ticdesc:=Resolve(Argument(a),c);
            ColorWrite2(c1,'changed Tic-Desc ......... ',c2,c.TICDESC,c3);
            ColorWriteLn;
         END;
      IF Key='BREAKSIGN' THEN
         BEGIN
            c.breaksign:=Argument(a);
            ColorWrite2(c1,'changed BreakSign ........ ',c2,c.BREAKSIGN,c3);
            ColorWriteLn;
         END;
      IF (Key='BREAK-PRODUCE') OR (Key='NEWPG-PRODUCE') THEN
         BEGIN
            IF Key='BREAK-PRODUCE' THEN
               c.break_np:=Break
            ELSE
               c.break_np:=NewPage;
            IF c.firstprod THEN
               BEGIN
                  c.firstprod:=FALSE;
                  RMassign(temptoc,c.beftoc);
                  CheckIO(RMrewrite(temptoc));
                  CheckIO(RMclose(temptoc));
                  RMassign(temptoc,c.afttoc);
                  CheckIO(RMrewrite(temptoc));
                  CheckIO(RMclose(temptoc));
                  RMassign(c.tochandle,c.tocname);
                  CheckIO(RMrewrite(c.tochandle));
               END;
            sec:=Resolve(Argument(a),c);
            Formatter(sec,c);
         END;
   END;

FUNCTION ReadCtrl(a:STRING;b:STRING;VAR ctrl:CtrlRec):BOOLEAN;
   VAR line:     STRING;
       handle:   text;
       ok:       BOOLEAN;
       x:        LONGINT;
       savepage: INTEGER;
   BEGIN
      (* some inits *)
      ctrl.tmpnum:=0;
      ctrl.months:='JanFebMarAprMayJunJulAugSepOctNovDec';
      ctrl.weekdays:='SuMoTuWeThFrSa';
      GetDate(ctrl.idate_jjjj,ctrl.idate_mm,ctrl.idate_dd,ctrl.idate_wd);
      ConvertDateA(ctrl);
      ctrl.ndate_jjjj:=ctrl.adate_jjjj;
      ctrl.ndate_jj  :=ctrl.adate_jj;
      ctrl.ndate_mmm :=ctrl.adate_mmm;
      ctrl.ndate_mm  :=ctrl.adate_mm;
      ctrl.ndate_m   :=ctrl.adate_m;
      ctrl.ndate_dd  :=ctrl.adate_dd;
      ctrl.ndate_d   :=ctrl.adate_d;
      ctrl.ndate_wd  :=ctrl.adate_wd;
      ctrl.hname:='FIDONEWS';
      ctrl.volume:=1;
      ConvertVolume(ctrl.volume,ctrl.volumef,ctrl.volumeh);
      ctrl.issue:=1;
      ctrl.news:='FNEWS';
      ConvertIssue(ctrl.issue,ctrl.issuef);
      GetDir(0,ctrl.issuedir);
      ctrl.issuedir:=ctrl.issuedir+'\'+ctrl.volumef+ctrl.issuef;
      ctrl.beftoc:=ctrl.issuedir+'\'+'TEMP.BT';
      ctrl.afttoc:=ctrl.issuedir+'\'+'TEMP.AT';
      ctrl.tocname:=ctrl.issuedir+'\'+'TEMP.TOC';
      ctrl.firstprod:=TRUE;
      GetDir(0,ctrl.includedir);
      ctrl.includedir:=ctrl.includedir+'\INCLUDE';
      ctrl.textfile:=ctrl.issuedir+'\'+'FIDO'+ctrl.volumef+ctrl.issuef+'.NWS';
      ctrl.arcname:=ctrl.issuedir+'\'+'FNEWS'+ctrl.volumeh+ctrl.issuef;
      ctrl.ticpath:=ctrl.issuedir;
      ctrl.packcommand:='PKZIP -ex -o '+ctrl.arcname+' '+ctrl.textfile;
      ctrl.pagelength:=59;
      ctrl.pagelength:=ctrl.pagelength-1;  (* start with 0 *)
      ctrl.width:=72;
      ctrl.offset:=5;
      ctrl.ticarea:='FIDONEWS';
      ctrl.ticaread:='FidoNet: Weekly FidoNews Newsletter';
      ctrl.ticpasswd:='fidonews';
      ctrl.ticown:='1:1/23';
      ctrl.ticdesc:='FidoNews volume '+ctrl.volumef+' issue '+ctrl.issuef+', '+ctrl.ndate_jjjj;
      ctrl.breaksign:='**=*=**';
      ctrl.tocwas:=Before;
      ctrl.linecount:=0;
      ctrl.startpage:=1;
      ctrl.page:=ctrl.startpage;
      ctrl.secnum:=0;
      ctrl.varstartpage:='Y';
      ctrl.toclines:=2;
      ctrl.tocfillchar:='.';
      ctrl.tocfil:='';
      WHILE Length(ctrl.tocfil)<80 DO
         ctrl.tocfil:=ctrl.tocfil+ctrl.tocfillchar;
      WriteCtrlRec(ctrl);

      (* First run for Variable-File *)
      IF LookForFile(a)=0 THEN
         BEGIN
            RMassign(handle,a);
            CheckIO(RMreset(handle));
            WHILE NOT EOF(handle) DO
               BEGIN
                  CheckIO(RMreadln(handle,line));
                  line:=Workup(line);
                  ChangeConfig(ctrl,line);
               END;
            CheckIO(RMclose(handle));
         END;

      (* Second run for more constant parameters *)
      RMassign(handle,b);
      CheckIO(RMreset(handle));
      WHILE NOT EOF(handle) DO
         BEGIN
            CheckIO(RMreadln(handle,line));
            line:=Workup(line);
            ChangeConfig(ctrl,line);
         END;
      CheckIO(RMclose(handle));

      CheckIO(RMclose(ctrl.tochandle));

      (* some kind of trick ;) - treat TOC as a normal Text and
         conncatenate it to TEMP.BT *)
      ctrl.tocwas:=Now;
      savepage:=ctrl.page;
      ctrl.page:=2;
      ctrl.headpath1:=ctrl.includedir+'\TOC.HED';
      ctrl.bannpath1:=ctrl.includedir+'\TOC.BAN';
      ctrl.footpath1:=ctrl.includedir+'\TOC.FOT';
      ctrl.headpath2:=ctrl.headpath1;
      ctrl.bannpath2:=ctrl.bannpath1;
      ctrl.footpath2:=ctrl.footpath1;
      ctrl.headpath3:=ctrl.headpath1;
      ctrl.bannpath3:=ctrl.bannpath1;
      ctrl.footpath3:=ctrl.footpath1;
      ColorWriteln;
      ColorWrite2(White,c_sectionf,LightCyan,'TOC',White);
      ColorWriteln;
      GetHBFPathes('H',ctrl);
      GetHBFPathes('B',ctrl);
      GetHBFPathes('F',ctrl);
      ctrl.firstincl:=TRUE; (* /w banner *)
      IncludeFile(ctrl.tocname,ctrl);
      ctrl.page:=savepage;
      (* now TEMP.TOC is concatenated to TEMP.BT *)

      IF LookForFile(ctrl.tocname)=0 THEN
         CheckIO(RMerase(ctrl.tocname));

   END;

PROCEDURE Merge2TextFiles(a,b,c:STRING);
   VAR x,y,z: text;
       buf:   STRING;
   PROCEDURE WriteFile(VAR r,s:text);
      BEGIN
         WHILE NOT EOF(r) DO
            BEGIN
               CheckIO(RMreadln(r,buf));
               CheckIO(RMwriteln(s,buf));
            END;
      END;
   BEGIN
      ColorWriteLn;
      ColorWrite2(White,c_merge1,LightGreen,a,White);
      ColorWriteLn;
      ColorWrite2(White,c_merge2,LightGreen,b,White);
      ColorWriteLn;
      ColorWrite2(White,c_merge3,LightGreen,c,White);
      ColorWriteLn;
      RMassign(x,a);
      RMassign(z,c);
      CheckIO(RMreset(x));
      CheckIO(RMrewrite(z));
      WriteFile(x,z);
      CheckIO(RMclose(x));
      RMassign(y,b);
      CheckIO(RMreset(y));
      WriteFile(y,z);
      CheckIO(RMwriteln(z,ff));
      CheckIO(RMclose(y));
      CheckIO(RMclose(z));
      IF LookForFile(c)=0 THEN
         BEGIN
            CheckIO(RMerase(a));
            CheckIO(RMerase(b));
         END;
   END;

PROCEDURE WriteNewVarFile(varf:STRING;VAR c:CtrlRec);
   VAR v: text;
       x: STRING;
   BEGIN
      RMassign(v,varf);
      CheckIO(RMrewrite(v));
      CheckIO(RMwriteln(v,'VOLUME='+c.volumef));
      ColorWriteLn;
      ColorWrite2(White,c_setvar,LightCyan,'VOLUME='+c.volumef,White);
      ColorWriteLn;
      STR(c.issue+1,x);
      CheckIO(RMwriteln(v,'ISSUE='+x));
      ColorWrite2(White,c_setvar,LightCyan,'ISSUE='+x,White);
      ColorWriteLn;
      IF c.varstartpage='Y' THEN
         STR(c.page,x)
      ELSE
         x:='1';
      CheckIO(RMwriteln(v,'STARTPAGE='+x));
      ColorWrite2(White,c_setvar,LightCyan,'STARTPAGE='+x,White);
      ColorWriteLn;
      CheckIO(RMclose(v));
   END;

PROCEDURE OpenLog;
   BEGIN
      IF LookForFile('RMNEWS.LOG')=0 THEN
         BEGIN
            RMassign(logfile,'RMNEWS.LOG');
            CheckIO(RMappend(logfile));
         END
      ELSE
         BEGIN
            RMassign(logfile,'RMNEWS.LOG');
            CheckIO(RMrewrite(logfile));
         END;
   END;

PROCEDURE CloseLog;
   BEGIN
      CheckIO(RMclose(logfile));
   END;

FUNCTION SetOutput(FileName: STRING): BOOLEAN;
   (* From SWAG-Library *)
   (* Why ? if command-string is to long, redirection with '>' won't go *)
   BEGIN
      FileName:=FileName+#0;
      SetOutput:=FALSE;
      ASM
	push ds
	mov  ax, ss
	mov  ds, ax
	lea  dx, FileName[1]
	mov  ah, 3Ch
	int  21h
	pop  ds
	jnc  @@1
	ret
	@@1:
	push ax
	mov  bx, ax
	mov  cx, Output.FileRec.Handle
	mov  ah, 46h
	int  21h
	mov  ah, 3Eh
	pop  bx
	jnc  @@2
	ret
	@@2:
	int  21h
      END;
      OutRedir:=TRUE;
      SetOutput:=TRUE;
   END;

PROCEDURE CancelOutput;
   VAR FileName: String[4];
   BEGIN
      IF NOT OutRedir THEN EXIT;
      FileName:='CON'#0;
      ASM
	push ds
	mov  ax, ss
	mov  ds, ax
	lea  dx, FileName[1]
	mov  ax, 3D01h
	int  21h
	pop  ds
	jnc  @@1
	ret
	@@1:
	push ax
	mov  bx, ax
	mov  cx, Output.FileRec.Handle
	mov  ah, 46h
	int  21h
	mov  ah, 3Eh
	pop  bx
	int  21h
      END;
      OutRedir:=FALSE;
   END;

PROCEDURE CallExternalPrg(command:STRING);
   VAR s: STRING;
       f: text;
   BEGIN
      IF LookForFile(elogfile)=0 THEN
         CheckIO(RMerase(elogfile));
      command:=' /C '+command;
      s:=GETENV('COMSPEC');
      ColorWriteLn;
      ColorWrite2(White,c_callpack,LightCyan,s+command,White);
      ColorWriteLn;
      ColorWriteLn;
      ColorWrite2(LightRed,'---',LightCyan,'ARCHIVER-PROTOCOL',White);
      ColorWrite2(LightRed,copy(minus+minus,1,50),LightCyan,'START',White);
      ColorWrite1(LightRed,'---',White);
      ColorWriteLn;
      CloseLog;

      SWAPVECTORS;
      SetOutput(elogfile);
      EXEC(s,command);
      CancelOutput;
      SWAPVECTORS;
      IF DosError<>0 THEN
         CheckIO(DosError);

      OpenLog;

      IF LookForFile(elogfile)=0 THEN
         BEGIN
            RMassign(f,elogfile);
            CheckIO(RMreset(f));
            WHILE NOT EOF(f) DO
               BEGIN
                  CheckIO(RMreadln(f,s));
                  ColorWrite1(White,s,White);
                  ColorWriteLn;
               END;
            CheckIO(RMclose(f));
            CheckIO(RMerase(elogfile));
         END;

      ColorWriteLn;
      ColorWrite2(LightRed,'---',LightCyan,'ARCHIVER-PROTOCOL',White);
      ColorWrite2(LightRed,copy(minus+minus,1,50),LightCyan,'END',White);
      ColorWrite1(LightRed,'-----',White);
      ColorWriteLn;
   END;

PROCEDURE Create_FileID_DIZ(VAR c:CtrlRec);
   CONST fid='FILE_ID.DIZ';
   VAR   s:       STRING;
         f:       text;
   BEGIN
      s:=c.ticpath+fid;
      ColorWriteLn;
      ColorWrite2(White,c_creafile,LightGreen,s,White);
      ColorWriteLn;
      RMassign(f,s);
      CheckIO(RMrewrite(f));
      CheckIO(RMwriteln(f,c.ticdesc));
      CheckIO(RMclose(f));
   END;

PROCEDURE Create_TIC(VAR c:CtrlRec);
   VAR   s: STRING;
         t: STRING;
         f: text;
         D: DirStr;
         N: NameStr;
         E: ExtStr;
   BEGIN
      s:=c.ticpath+'RM'+c.volumef+c.issuef+'00.TIC';
      ColorWriteLn;
      ColorWrite2(White,c_creafile,LightGreen,s,White);
      ColorWriteLn;
      RMassign(f,s);
      CheckIO(RMrewrite(f));
      CheckIO(RMwriteln(f,'Area '+c.ticarea));
      CheckIO(RMwriteln(f,'Areadesc '+c.ticaread));
      CheckIO(RMwriteln(f,'Origin '+c.ticown));
      CheckIO(RMwriteln(f,'From '+c.ticown));
      FSplit(c.arcname,D,N,E);
      CheckIO(RMwriteln(f,'File '+N+E));
      CheckIO(RMwriteln(f,'Desc '+c.ticdesc));
      CheckIO(RMwriteln(f,'Ldesc '+c.ticdesc));
      t:=PrgName+', v'+Version+' by '+Author+' (Public Domain) '+Year+' '+Node;
      CheckIO(RMwriteln(f,'Created by '+t));
      CheckIO(RMwriteln(f,'Pw '+c.ticpasswd));
      CheckIO(RMclose(f));
   END;

BEGIN

   opened:=0;

   OpenLog;

   s:=PrgName+' v'+Version+' by '+Author+' (Public Domain) '+Year+' '+Node;

   ColorWriteLn;
   ColorWrite1(White,s,White);
   ColorWriteLn;
   ColorWrite1(White,copy(equal,1,Length(s)),White);
   ColorWriteLn;

   ReadCtrl(varfile,ctlfile,ctrlstruct);

   (* merging TEMP.BT and TEMP.AT to $TEXTFILE *)
   Merge2TextFiles(ctrlstruct.beftoc,ctrlstruct.afttoc,ctrlstruct.textfile);

   (* Create New VarFile with Volume=, ISSUE=, STARTPAGE= *)
   WriteNewVarFile(varfile,ctrlstruct);

   (* Create Fileid.DIZ with description *)
   Create_FileID_DIZ(ctrlstruct);

   (* produce archive *)
   IF LookForFile(ctrlstruct.arcname)=0 THEN
      CheckIO(RMerase(ctrlstruct.arcname));
   CallExternalPrg(ctrlstruct.packcommand);

   (* create TIC-File *)
   Create_TIC(ctrlstruct);

   ColorWriteLn;
   ColorWrite1(White,'End of RMNEWS.',White);
   ColorWriteLn;
   ColorWriteLn;

   CloseLog;

END.
